<?
sapp_include_once('common.php');

function form_handler()
{
	$valid = true;

	// check ssl
	$ssl = sapp_get_submit_value('ssl');
	switch ($ssl) {
		case 'true':
			sapp_set_ssl(true);
			break;

		default:
			sapp_set_ssl(false);
			break;
	}

	// check install_prefix
    // check install_prefix
    $install_prefix = sapp_get_submit_value('install_prefix');
    if (in_array($install_prefix, array(".", "/", "./")))
    {
        $ret = (function_exists('sapp_check_install_prefix'))? sapp_check_install_prefix(SITEAPP_PREFIX_ROOT) : false;
        if (false===$ret || false === in_array($ret, array(SITEAPP_DIR_NOT_EXISTS, SITEAPP_DIR_USED_BY_UNKNOWN)))
        {
            sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
            $valid = false;
        }
    }

	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}

	$pb_admin_email = sapp_get_submit_value('pb_admin_email');
	if (!check_email($pb_admin_email)) {
		sapp_set_wrong('pb_admin_email', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('pb_admin_email', $pb_admin_email);

	//check db name
	$pb_dbname = sapp_get_submit_value('pb_dbname');
	if (!check_dbName($pb_dbname)) {
		sapp_set_wrong('pb_dbname', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('pb_dbname', $pb_dbname);

	if (sapp_is_database_exists($pb_dbname, 'mysql')) {
		sapp_set_wrong('pb_dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$pb_dbuser = sapp_get_submit_value('pb_dbuser');
	if (!check_dbUserName($pb_dbuser)) {
		sapp_set_wrong('pb_dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('pb_dbuser', $pb_dbuser);

	//check db passwd
	$pb_dbpasswd = sapp_get_submit_value('pb_dbpasswd');
	$pb_dbconfirm = sapp_get_submit_value('pb_dbconfirm');
	if ('' == $pb_dbpasswd) {
		if (!sapp_get_param('pb_dbpasswd')) {
			sapp_set_wrong('pb_dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$pb_dbpasswd = sapp_get_param('pb_dbpasswd');
		}
	} elseif ($pb_dbpasswd != $pb_dbconfirm) {
		sapp_set_wrong('pb_dbpasswd', msg('password__not_match'));
		sapp_set_wrong('pb_dbconfirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('pb_dbpasswd', $pb_dbpasswd);
	}
	
	if (sapp_is_database_user_exists($pb_dbname, 'mysql', $pb_dbuser, $pb_dbpasswd)) {
		sapp_set_wrong('pb_dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}
	
	//check admin password
	$pb_admin_passwd = sapp_get_submit_value('pb_admin_passwd');
	$pb_admin_confirm = sapp_get_submit_value('pb_admin_confirm');
	if ('' == $pb_admin_passwd) {
		if (!sapp_get_param('pb_admin_passwd')) {
			sapp_set_wrong('pb_admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$pb_admin_passwd = sapp_get_param('pb_admin_passwd');
		}
	} elseif ($pb_admin_passwd != $pb_admin_confirm) {
		sapp_set_wrong('pb_admin_passwd', msg('password__not_match'));
		sapp_set_wrong('pb_admin_confirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('pb_admin_passwd', $pb_admin_passwd);
	}
	
	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($pb_dbname, 'mysql')) {
		sapp_set_wrong('pb_dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($pb_dbname, 'mysql', $pb_dbuser, $pb_dbpasswd)) {
		sapp_set_wrong('pb_dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	return 2;
}
?>
